// Super Emboss // for quick and graphical effets
//  karistouf@yahoo.fr http://karistouf.free.fr
// This version is provided under a Creative Commons Attribution 3.0 License
// http://creativecommons.org/licenses/by/3.0/ 


//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (EX9)
float4x4 tWVP: WORLDVIEWPROJECTION;



//texture
texture Tex <string uiname="Texture";>;
sampler Texture = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;
/////Variables filtrage
float rOffset  <string uiname="red offset";>;
float gOffset  <string uiname="green offset";>;
float bOffset  <string uiname="blue offset";>;

float fContrastColor  <string uiname="contrastColor at beg";>;
float fContrast  <string uiname="contrast at end";>;

float adjust  <string uiname="adjust emboss offset";>;
float alpha   <string uiname="alpha";>;
bool bmonochrome <string uiname="grey monochrome";>;


// Input and Output Semantics
struct VS_INPUT
{
   float4 position : POSITION;
   float2 texCoord : TEXCOORD;
};
struct VS_OUTPUT
{
   float4 position : POSITION;
   float2 texCoord : TEXCOORD;
};
#define PS_INPUT VS_OUTPUT

//Vertex Shader Output
VS_OUTPUT vs_main(const VS_INPUT IN)
{
   VS_OUTPUT OUT;

   OUT.position = mul(IN.position, tWVP);
   OUT.texCoord = mul(IN.texCoord, tTex);

   return OUT;
}
//PIXEL SHADER
float4 ps_super_emboss( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 Color = float4(rOffset*fContrastColor,gOffset*fContrastColor, bOffset*fContrastColor,alpha); // medium grey




	  Color += tex2D( Texture, Tex.xy+adjust)*fContrast;
	  Color -= tex2D( Texture, Tex.xy-adjust)*fContrast;
  if(bmonochrome==1)
  {
  Color.rgb = (Color.r+Color.g+Color.b)*alpha ; // make monochrome
  }
	return Color;
}

//Technique Calls
technique SuperEmboss
{
   pass Pass_0
   {
      VertexShader = compile vs_1_1 vs_main();
      PixelShader = compile ps_2_0 ps_super_emboss();
   }
}
